3
0
Fork 0
forked from mirrors/nixpkgs

Merge branch 'kde-5' into staging

This commit is contained in:
Thomas Tuegel 2016-04-20 10:01:20 -05:00
commit 76d2a1cbb6
29 changed files with 570 additions and 269 deletions

View file

@ -98,9 +98,9 @@ in {
package = mkOption {
type = types.package;
default = pulseaudioLight;
defaultText = "pkgs.pulseaudioLight";
example = literalExample "pkgs.pulseaudioFull";
default = pulseaudioLight.out;
defaultText = "pkgs.pulseaudioLight.out";
example = literalExample "pkgs.pulseaudioFull.out";
description = ''
The PulseAudio derivation to use. This can be used to enable
features (such as JACK support, Bluetooth) via the

View file

@ -62,17 +62,25 @@ in
${config.hardware.pulseaudio.package}/bin/pactl load-module module-device-manager "do_routing=1"
''}
exec startkde
exec "${kde5.startkde}"
'';
};
security.setuidOwners = singleton {
program = "kcheckpass";
source = "${kde5.plasma-workspace.out}/lib/libexec/kcheckpass";
owner = "root";
group = "root";
setuid = true;
};
security.setuidOwners = [
{
program = "kcheckpass";
source = "${kde5.plasma-workspace}/lib/libexec/kcheckpass";
owner = "root";
setuid = true;
}
{
program = "start_kdeinit_wrapper";
source = "${kde5.plasma-workspace}/lib/libexec/kf5/start_kdeinit_wrapper";
owner = "root";
setuid = true;
}
];
environment.systemPackages =
[

View file

@ -7,7 +7,6 @@ _ecmSetXdgDirs() {
_ecmPropagateSharedData() {
local sharedPaths=( \
"config.cfg" \
"doc" \
"kconf_update" \
"kservices5" \
"kservicetypes5" \
@ -20,7 +19,6 @@ _ecmPropagateSharedData() {
"applications" \
"desktop-directories" \
"mime" \
"info" \
"dbus-1" \
"interfaces" \
"services" \
@ -28,6 +26,7 @@ _ecmPropagateSharedData() {
for dir in ${sharedPaths[@]}; do
if [ -d "$1/share/$dir" ]; then
addToSearchPathOnce NIX_WRAP_XDG_DATA_DIRS "$1/share"
propagateOnce propagatedBuildInputs "$1"
propagateOnce propagatedUserEnvPkgs "$1"
break
fi

View file

@ -9,7 +9,8 @@ kdeFramework {
propagatedBuildInputs = [ kauth kconfig kcodecs ki18n kwidgetsaddons ];
patches = [ ./0001-qdiriterator-follow-symlinks.patch ];
postInstall = ''
wrapQtProgram "$out/bin/preparetips5"
moveToOutput "bin/preparetips5" "$dev"
wrapQtProgram "$dev/bin/preparetips5"
'';
meta = {
maintainers = [ lib.maintainers.ttuegel ];

View file

@ -1,42 +0,0 @@
From 723c9b1268a04127647a1c20eebe9804150566dd Mon Sep 17 00:00:00 2001
From: Thomas Tuegel <ttuegel@gmail.com>
Date: Sat, 13 Jun 2015 08:57:55 -0500
Subject: [PATCH] kinit libpath
---
src/kdeinit/kinit.cpp | 18 ++++++++++--------
1 file changed, 10 insertions(+), 8 deletions(-)
diff --git a/src/kdeinit/kinit.cpp b/src/kdeinit/kinit.cpp
index 9e775b6..0ac5646 100644
--- a/src/kdeinit/kinit.cpp
+++ b/src/kdeinit/kinit.cpp
@@ -660,15 +660,17 @@ static pid_t launch(int argc, const char *_name, const char *args,
if (!libpath.isEmpty()) {
if (!l.load()) {
if (libpath_relative) {
- // NB: Because Qt makes the actual dlopen() call, the
- // RUNPATH of kdeinit is *not* respected - see
- // https://sourceware.org/bugzilla/show_bug.cgi?id=13945
- // - so we try hacking it in ourselves
- QString install_lib_dir = QFile::decodeName(
- CMAKE_INSTALL_PREFIX "/" LIB_INSTALL_DIR "/");
- libpath = install_lib_dir + libpath;
- l.setFileName(libpath);
+ // Use QT_PLUGIN_PATH to find shared library directories
+ // For KF5, the plugin path is /lib/qt5/plugins/, so kdeinit5
+ // shared libraries should be in /lib/qt5/plugins/../../
+ const QRegExp pathSepRegExp(QString::fromLatin1("[:\b]"));
+ const QString up = QString::fromLocal8Bit("/../../");
+ const QStringList paths = QString::fromLocal8Bit(qgetenv("QT_PLUGIN_PATH")).split(pathSepRegExp, QString::KeepEmptyParts);
+ Q_FOREACH (const QString &path, paths) {
+ l.setFileName(path + up + libpath);
l.load();
+ if (l.isLoaded()) break;
+ }
}
}
if (!l.isLoaded()) {
--
2.4.2

View file

@ -1,4 +1,4 @@
{ kdeFramework, lib, extra-cmake-modules, kconfig, kcrash
{ kdeFramework, lib, copyPathsToStore, extra-cmake-modules, kconfig, kcrash
, kdoctools, ki18n, kio, kservice, kwindowsystem, libcap
, libcap_progs
}:
@ -10,7 +10,7 @@ kdeFramework {
nativeBuildInputs = [ extra-cmake-modules kdoctools libcap_progs ];
buildInputs = [ kconfig kcrash kservice libcap ];
propagatedBuildInputs = [ ki18n kio kwindowsystem ];
patches = [ ./0001-kinit-libpath.patch ];
patches = copyPathsToStore (lib.readPathsFromFile ./. ./series);
meta = {
maintainers = [ lib.maintainers.ttuegel ];
};

View file

@ -0,0 +1,31 @@
Index: kinit-5.19.0/src/kdeinit/kinit.cpp
===================================================================
--- kinit-5.19.0.orig/src/kdeinit/kinit.cpp
+++ kinit-5.19.0/src/kdeinit/kinit.cpp
@@ -658,15 +658,17 @@ static pid_t launch(int argc, const char
if (!libpath.isEmpty()) {
if (!l.load()) {
if (libpath_relative) {
- // NB: Because Qt makes the actual dlopen() call, the
- // RUNPATH of kdeinit is *not* respected - see
- // https://sourceware.org/bugzilla/show_bug.cgi?id=13945
- // - so we try hacking it in ourselves
- QString install_lib_dir = QFile::decodeName(
- CMAKE_INSTALL_PREFIX "/" LIB_INSTALL_DIR "/");
- libpath = install_lib_dir + libpath;
- l.setFileName(libpath);
- l.load();
+ // Try to load the library relative to the active profiles.
+ QByteArrayList profiles = qgetenv("NIX_PROFILES").split(' ');
+ // Reverse the profile list.
+ std::reverse(profiles.begin(), profiles.end());
+ const QString libdir = QString::fromLatin1("/lib/");
+ Q_FOREACH (const QByteArray &profile, profiles) {
+ if (!profile.isEmpty()) {
+ l.setFileName(QFile::decodeName(profile) + libdir + libpath);
+ if (l.load()) break;
+ }
+ }
}
}
if (!l.isLoaded()) {

View file

@ -0,0 +1 @@
kinit-libpath.patch

View file

@ -81,6 +81,7 @@ let
plasma-workspace-wallpapers = callPackage ./plasma-workspace-wallpapers.nix {};
polkit-kde-agent = callPackage ./polkit-kde-agent.nix {};
powerdevil = callPackage ./powerdevil.nix {};
startkde = callPackage ./startkde {};
systemsettings = callPackage ./systemsettings.nix {};
};

View file

@ -1,14 +1,12 @@
{ plasmaPackage, lib, copyPathsToStore
, extra-cmake-modules, kdoctools, makeQtWrapper
, extra-cmake-modules, kdoctools
, baloo, kactivities, kcmutils, kcrash, kdbusaddons, kdeclarative
, kdelibs4support, kdesu, kdewebkit, kglobalaccel, kidletime
, kjsembed, knewstuff, knotifyconfig, kpackage, krunner
, ktexteditor, ktextwidgets, kwallet, kwayland, kwin, kxmlrpcclient
, libdbusmenu, libkscreen, libSM, libXcursor, networkmanager-qt
, pam, phonon, plasma-framework, qtquick1, qtscript, qtx11extras, wayland
, libksysguard, bash, coreutils, gnused, gnugrep, socat, kconfig
, kinit, kservice, qttools, dbus_tools, mkfontdir, xmessage
, xprop, xrdb, xset, xsetroot, solid, qtquickcontrols
, libksysguard, kconfig, solid, qtquickcontrols
}:
plasmaPackage {
@ -17,14 +15,13 @@ plasmaPackage {
nativeBuildInputs = [
extra-cmake-modules
kdoctools
makeQtWrapper
];
buildInputs = [
dbus_tools kcmutils kconfig kcrash kdbusaddons kdesu kdewebkit
kinit kjsembed knewstuff knotifyconfig kpackage kservice
kcmutils kconfig kcrash kdbusaddons kdesu kdewebkit
kjsembed knewstuff knotifyconfig kpackage
ktextwidgets kwallet kwayland kxmlrpcclient libdbusmenu libSM
libXcursor mkfontdir networkmanager-qt pam phonon qtscript qttools
socat wayland xmessage xprop xset xsetroot
libXcursor networkmanager-qt pam phonon qtscript
wayland
];
propagatedBuildInputs = [
baloo kactivities kdeclarative kdelibs4support kglobalaccel
@ -35,50 +32,14 @@ plasmaPackage {
patches = copyPathsToStore (lib.readPathsFromFile ./. ./series);
postPatch = ''
substituteInPlace startkde/startkde.cmake \
--subst-var-by bash $(type -P bash) \
--subst-var-by sed $(type -P sed) \
--subst-var-by grep $(type -P grep) \
--subst-var-by socat $(type -P socat) \
--subst-var-by kcheckrunning $(type -P kcheckrunning) \
--subst-var-by xmessage $(type -P xmessage) \
--subst-var-by tr $(type -P tr) \
--subst-var-by qtpaths $(type -P qtpaths) \
--subst-var-by qdbus $(type -P qdbus) \
--subst-var-by dbus-launch $(type -P dbus-launch) \
--subst-var-by mkfontdir $(type -P mkfontdir) \
--subst-var-by xset $(type -P xset) \
--subst-var-by xsetroot $(type -P xsetroot) \
--subst-var-by xprop $(type -P xprop) \
--subst-var-by start_kdeinit_wrapper "${kinit.out}/lib/libexec/kf5/start_kdeinit_wrapper" \
--subst-var-by kwrapper5 $(type -P kwrapper5) \
--subst-var-by kdeinit5_shutdown $(type -P kdeinit5_shutdown) \
--subst-var-by kbuildsycoca5 $(type -P kbuildsycoca5) \
--subst-var-by kreadconfig5 $(type -P kreadconfig5) \
--subst-var out
substituteInPlace startkde/kstartupconfig/kstartupconfig.cpp \
--replace kdostartupconfig5 $out/bin/kdostartupconfig5
'';
postInstall = ''
rm "$out/bin/startkde"
rm "$out/bin/startplasmacompositor"
rm "$out/lib/libexec/startplasma"
rm -r "$out/share/wayland-sessions"
'';
postFixup = ''
wrapQtProgram "$out/bin/ksmserver"
wrapQtProgram "$out/bin/plasmawindowed"
wrapQtProgram "$out/bin/kcminit_startup"
wrapQtProgram "$out/bin/ksplashqml"
wrapQtProgram "$out/bin/kcheckrunning"
wrapQtProgram "$out/bin/systemmonitor"
wrapQtProgram "$out/bin/kstartupconfig5"
wrapQtProgram "$out/bin/kdostartupconfig5"
wrapQtProgram "$out/bin/klipper"
wrapQtProgram "$out/bin/kuiserver5"
wrapQtProgram "$out/bin/krunner"
wrapQtProgram "$out/bin/plasmashell"
wrapQtProgram "$out/lib/libexec/drkonqi"
'';
}

View file

@ -1,2 +1 @@
startkde.patch
qml-import-path.patch

View file

@ -0,0 +1,32 @@
{ stdenv, lib, runCommand
, dbus, qttools, socat
, gnugrep, gnused
, kconfig, kinit, kservice
, plasma-workspace
, xmessage, xprop, xsetroot
}:
let
env = {
inherit (stdenv) shell;
paths = builtins.map (pkg: pkg.out or pkg)
[
dbus qttools socat
gnugrep gnused
kconfig kinit kservice
plasma-workspace
xmessage xprop xsetroot
];
};
in runCommand "startkde" env ''
prefix_PATH=
for pkg in $paths; do
addToSearchPath prefix_PATH "$pkg/bin"
addToSearchPath prefix_PATH "$pkg/lib/libexec"
addToSearchPath prefix_PATH "$pkg/lib/libexec/kf5"
done
substitute ${./startkde.sh} "$out" --subst-var shell --subst-var prefix_PATH
chmod +x "$out"
''

View file

@ -0,0 +1,334 @@
#!@shell@
PATH="@prefix_PATH@:$PATH"
# The KDE icon cache is supposed to update itself
# automatically, but it uses the timestamp on the icon
# theme directory as a trigger. Since in Nix the
# timestamp is always the same, this doesn't work. So as
# a workaround, nuke the icon cache on login. This isn't
# perfect, since it may require logging out after
# installing new applications to update the cache.
# See http://lists-archives.org/kde-devel/26175-what-when-will-icon-cache-refresh.html
rm -fv $HOME/.cache/icon-cache.kcache
# Qt writes a weird libraryPath line to
# ~/.config/Trolltech.conf that causes the KDE plugin
# paths of previous KDE invocations to be searched.
# Obviously using mismatching KDE libraries is potentially
# disastrous, so here we nuke references to the Nix store
# in Trolltech.conf. A better solution would be to stop
# Qt from doing this wackiness in the first place.
if [ -e $HOME/.config/Trolltech.conf ]; then
sed -e '/nix\\store\|nix\/store/ d' -i $HOME/.config/Trolltech.conf
fi
if test "x$1" = x--failsafe; then
KDE_FAILSAFE=1 # General failsafe flag
KWIN_COMPOSE=N # Disable KWin's compositing
QT_XCB_FORCE_SOFTWARE_OPENGL=1
export KWIN_COMPOSE KDE_FAILSAFE QT_XCB_FORCE_SOFTWARE_OPENGL
fi
# When the X server dies we get a HUP signal from xinit. We must ignore it
# because we still need to do some cleanup.
trap 'echo GOT SIGHUP' HUP
# we have to unset this for Darwin since it will screw up KDE's dynamic-loading
unset DYLD_FORCE_FLAT_NAMESPACE
# Check if a KDE session already is running and whether it's possible to connect to X
kcheckrunning
kcheckrunning_result=$?
if test $kcheckrunning_result -eq 0 ; then
echo "KDE seems to be already running on this display."
xmessage -geometry 500x100 "KDE seems to be already running on this display."
exit 1
elif test $kcheckrunning_result -eq 2 ; then
echo "\$DISPLAY is not set or cannot connect to the X server."
exit 1
fi
# Boot sequence:
#
# kdeinit is used to fork off processes which improves memory usage
# and startup time.
#
# * kdeinit starts klauncher first.
# * Then kded is started. kded is responsible for keeping the sycoca
# database up to date. When an up to date database is present it goes
# into the background and the startup continues.
# * Then kdeinit starts kcminit. kcminit performs initialisation of
# certain devices according to the user's settings
#
# * Then ksmserver is started which takes control of the rest of the startup sequence
# We need to create config folder so we can write startupconfigkeys
configDir=$(qtpaths --writable-path GenericConfigLocation)
mkdir -p "$configDir"
#This is basically setting defaults so we can use them with kstartupconfig5
cat >$configDir/startupconfigkeys <<EOF
kcminputrc Mouse cursorTheme 'breeze_cursors'
kcminputrc Mouse cursorSize ''
ksplashrc KSplash Theme Breeze
ksplashrc KSplash Engine KSplashQML
kdeglobals KScreen ScaleFactor 1
kcmfonts General forceFontDPI 0
EOF
# preload the user's locale on first start
plasmalocalerc=$configDir/plasma-localerc
test -f $plasmalocalerc || {
cat >$plasmalocalerc <<EOF
[Formats]
LANG=$LANG
EOF
}
# export LC_* variables set by kcmshell5 formats into environment
# so it can be picked up by QLocale and friends.
exportformatssettings=$configDir/plasma-locale-settings.sh
test -f $exportformatssettings && {
. $exportformatssettings
}
# Write a default kdeglobals file to set up the font
kdeglobalsfile=$configDir/kdeglobals
test -f $kdeglobalsfile || {
cat >$kdeglobalsfile <<EOF
[General]
XftAntialias=true
XftHintStyle=hintmedium
XftSubPixel=none
EOF
}
kstartupconfig5
returncode=$?
if test $returncode -ne 0; then
xmessage -geometry 500x100 "kstartupconfig5 does not exist or fails. The error code is $returncode. Check your installation."
exit 1
fi
[ -r $configDir/startupconfig ] && . $configDir/startupconfig
if test "$kdeglobals_kscreen_scalefactor" -ne 1; then
export QT_DEVICE_PIXEL_RATIO=$kdeglobals_kscreen_scalefactor
fi
XCURSOR_PATH=~/.icons
IFS=":" read -r -a xdgDirs <<< "$XDG_DATA_DIRS"
for xdgDir in "${xdgDirs[@]}"; do
XCURSOR_PATH="$XCURSOR_PATH:$xdgDir/icons"
done
export XCURSOR_PATH
# XCursor mouse theme needs to be applied here to work even for kded or ksmserver
if test -n "$kcminputrc_mouse_cursortheme" -o -n "$kcminputrc_mouse_cursorsize" ; then
kapplymousetheme "$kcminputrc_mouse_cursortheme" "$kcminputrc_mouse_cursorsize"
if test $? -eq 10; then
XCURSOR_THEME=breeze_cursors
export XCURSOR_THEME
elif test -n "$kcminputrc_mouse_cursortheme"; then
XCURSOR_THEME="$kcminputrc_mouse_cursortheme"
export XCURSOR_THEME
fi
if test -n "$kcminputrc_mouse_cursorsize"; then
XCURSOR_SIZE="$kcminputrc_mouse_cursorsize"
export XCURSOR_SIZE
fi
fi
# Set a left cursor instead of the standard X11 "X" cursor, since I've heard
# from some users that they're confused and don't know what to do. This is
# especially necessary on slow machines, where starting KDE takes one or two
# minutes until anything appears on the screen.
#
# If the user has overwritten fonts, the cursor font may be different now
# so don't move this up.
#
xsetroot -cursor_name left_ptr
dl=$DESKTOP_LOCKED
unset DESKTOP_LOCKED # Don't want it in the environment
# Make sure that D-Bus is running
# D-Bus autolaunch is broken
if test -z "$DBUS_SESSION_BUS_ADDRESS" ; then
eval $(dbus-launch --sh-syntax --exit-with-session)
fi
if qdbus >/dev/null 2>/dev/null; then
: # ok
else
echo 'startkde: Could not start D-Bus. Can you call qdbus?' 1>&2
test -n "$ksplash_pid" && kill "$ksplash_pid" 2>/dev/null
xmessage -geometry 500x100 "Could not start D-Bus. Can you call qdbus?"
exit 1
fi
ksplash_pid=
if test -z "$dl"; then
# the splashscreen and progress indicator
case "$ksplashrc_ksplash_engine" in
KSplashQML)
ksplash_pid=$(ksplashqml "${ksplashrc_ksplash_theme}" --pid)
;;
None)
;;
*)
;;
esac
fi
# Source scripts found in <config locations>/plasma-workspace/env/*.sh
# (where <config locations> correspond to the system and user's configuration
# directories, as identified by Qt's qtpaths, e.g. $HOME/.config
# and /etc/xdg/ on Linux)
#
# This is where you can define environment variables that will be available to
# all KDE programs, so this is where you can run agents using e.g. eval `ssh-agent`
# or eval `gpg-agent --daemon`.
# Note: if you do that, you should also put "ssh-agent -k" as a shutdown script
#
# (see end of this file).
# For anything else (that doesn't set env vars, or that needs a window manager),
# better use the Autostart folder.
IFS=":" read -r -a scriptpath <<< $(qtpaths --paths GenericConfigLocation)
# Add /env/ to the directory to locate the scripts to be sourced
for prefix in "${scriptpath[@]}"; do
for file in "$prefix"/plasma-workspace/env/*.sh; do
test -r "$file" && . "$file" || true
done
done
echo 'startkde: Starting up...' 1>&2
# Mark that full KDE session is running (e.g. Konqueror preloading works only
# with full KDE running). The KDE_FULL_SESSION property can be detected by
# any X client connected to the same X session, even if not launched
# directly from the KDE session but e.g. using "ssh -X", kdesu. $KDE_FULL_SESSION
# however guarantees that the application is launched in the same environment
# like the KDE session and that e.g. KDE utilities/libraries are available.
# KDE_FULL_SESSION property is also only available since KDE 3.5.5.
# The matching tests are:
# For $KDE_FULL_SESSION:
# if test -n "$KDE_FULL_SESSION"; then ... whatever
# For KDE_FULL_SESSION property:
# xprop -root | grep "^KDE_FULL_SESSION" >/dev/null 2>/dev/null
# if test $? -eq 0; then ... whatever
#
# Additionally there is (since KDE 3.5.7) $KDE_SESSION_UID with the uid
# of the user running the KDE session. It should be rarely needed (e.g.
# after sudo to prevent desktop-wide functionality in the new user's kded).
#
# Since KDE4 there is also KDE_SESSION_VERSION, containing the major version number.
# Note that this didn't exist in KDE3, which can be detected by its absense and
# the presence of KDE_FULL_SESSION.
#
KDE_FULL_SESSION=true
export KDE_FULL_SESSION
xprop -root -f KDE_FULL_SESSION 8t -set KDE_FULL_SESSION true
KDE_SESSION_VERSION=5
export KDE_SESSION_VERSION
xprop -root -f KDE_SESSION_VERSION 32c -set KDE_SESSION_VERSION 5
KDE_SESSION_UID=`id -ru`
export KDE_SESSION_UID
XDG_CURRENT_DESKTOP=KDE
export XDG_CURRENT_DESKTOP
# At this point all the environment is ready, let's send it to kwalletd if running
if test -n "$PAM_KWALLET_LOGIN" ; then
env | socat STDIN UNIX-CONNECT:$PAM_KWALLET_LOGIN
fi
# ...and also to kwalletd5
if test -n "$PAM_KWALLET5_LOGIN" ; then
env | socat STDIN UNIX-CONNECT:$PAM_KWALLET5_LOGIN
fi
# At this point all environment variables are set, let's send it to the DBus session server to update the activation environment
ksyncdbusenv
if test $? -ne 0; then
# Startup error
echo 'startkde: Could not sync environment to dbus.' 1>&2
test -n "$ksplash_pid" && kill "$ksplash_pid" 2>/dev/null
xmessage -geometry 500x100 "Could not sync environment to dbus."
exit 1
fi
# We set LD_BIND_NOW to increase the efficiency of kdeinit.
# kdeinit unsets this variable before loading applications.
LD_BIND_NOW=true start_kdeinit_wrapper --kded +kcminit_startup
if test $? -ne 0; then
# Startup error
echo 'startkde: Could not start kdeinit5. Check your installation.' 1>&2
test -n "$ksplash_pid" && kill "$ksplash_pid" 2>/dev/null
xmessage -geometry 500x100 "Could not start kdeinit5. Check your installation."
exit 1
fi
# (NixOS) Run kbuildsycoca5 before starting the user session because things
# may be missing or moved if they have run nixos-rebuild and it may not be
# possible for them to start Konsole to run it manually!
kbuildsycoca5
# finally, give the session control to the session manager
# see kdebase/ksmserver for the description of the rest of the startup sequence
# if the KDEWM environment variable has been set, then it will be used as KDE's
# window manager instead of kwin.
# if KDEWM is not set, ksmserver will ensure kwin is started.
# kwrapper5 is used to reduce startup time and memory usage
# kwrapper5 does not return useful error codes such as the exit code of ksmserver.
# We only check for 255 which means that the ksmserver process could not be
# started, any problems thereafter, e.g. ksmserver failing to initialize,
# will remain undetected.
test -n "$KDEWM" && KDEWM="--windowmanager $KDEWM"
# If the session should be locked from the start (locked autologin),
# lock now and do the rest of the KDE startup underneath the locker.
KSMSERVEROPTIONS=""
test -n "$dl" && KSMSERVEROPTIONS=" --lockscreen"
kwrapper5 ksmserver $KDEWM $KSMSERVEROPTIONS
if test $? -eq 255; then
# Startup error
echo 'startkde: Could not start ksmserver. Check your installation.' 1>&2
test -n "$ksplash_pid" && kill "$ksplash_pid" 2>/dev/null
xmessage -geometry 500x100 "Could not start ksmserver. Check your installation."
fi
wait_drkonqi=$(kreadconfig5 --file startkderc --group WaitForDrKonqi --key Enabled --default true)
if test x"$wait_drkonqi"x = x"true"x ; then
# wait for remaining drkonqi instances with timeout (in seconds)
wait_drkonqi_timeout=$(kreadconfig5 --file startkderc --group WaitForDrKonqi --key Timeout --default 900)
wait_drkonqi_counter=0
while qdbus | grep "^[^w]*org.kde.drkonqi" > /dev/null ; do
sleep 5
wait_drkonqi_counter=$((wait_drkonqi_counter+5))
if test "$wait_drkonqi_counter" -ge "$wait_drkonqi_timeout" ; then
# ask remaining drkonqis to die in a graceful way
qdbus | grep 'org.kde.drkonqi-' | while read address ; do
qdbus "$address" "/MainApplication" "quit"
done
break
fi
done
fi
echo 'startkde: Shutting down...' 1>&2
# just in case
test -n "$ksplash_pid" && kill "$ksplash_pid" 2>/dev/null
# Clean up
kdeinit5_shutdown
unset KDE_FULL_SESSION
xprop -root -remove KDE_FULL_SESSION
unset KDE_SESSION_VERSION
xprop -root -remove KDE_SESSION_VERSION
unset KDE_SESSION_UID
echo 'startkde: Done.' 1>&2

View file

@ -6,8 +6,8 @@ assert x11Support -> libX11 != null
&& libSM != null;
let
version = "1.8.20";
sha256 = "0fkh3d5r57a659hw9lqnw4v0bc5556vx54fsf7l9c732ci6byksw";
version = "1.10.8";
sha256 = "0560y3hxpgh346w6avcrcz79c8ansmn771y5xpcvvlr6m8mx5wxs";
self = stdenv.mkDerivation {
name = "dbus-${version}";
@ -17,8 +17,7 @@ self = stdenv.mkDerivation {
inherit sha256;
};
patches = [ ./ignore-missing-includedirs.patch ]
++ lib.optional stdenv.isSunOS ./implement-getgrouplist.patch;
patches = lib.optional stdenv.isSunOS ./implement-getgrouplist.patch;
postPatch = ''
substituteInPlace tools/Makefile.in \
--replace 'install-localstatelibDATA:' 'disabled:' \

View file

@ -1,23 +0,0 @@
diff -ru -x '*~' dbus-1.2.24-orig/bus/config-parser.c dbus-1.2.24/bus/config-parser.c
--- dbus-1.2.24-orig/bus/config-parser.c 2010-03-23 20:01:27.000000000 +0100
+++ dbus-1.2.24/bus/config-parser.c 2010-07-20 14:17:20.000000000 +0200
@@ -2159,12 +2159,16 @@
retval = FALSE;
- dir = _dbus_directory_open (dirname, error);
+ dbus_error_init (&tmp_error);
+
+ dir = _dbus_directory_open (dirname, &tmp_error);
if (dir == NULL)
- goto failed;
+ {
+ retval = TRUE;
+ goto failed;
+ }
- dbus_error_init (&tmp_error);
while (_dbus_directory_get_next_file (dir, &filename, &tmp_error))
{
DBusString full_path;

View file

@ -1,8 +1,7 @@
{ stdenv, fetchurl, cmake, automoc4, qt4, pkgconfig, phonon, gstreamer
, gst_plugins_base }:
{ stdenv, fetchurl, cmake, automoc4, qt4, pkgconfig, phonon, gst_all_1 }:
let
version = "4.7.2";
version = "4.8.2";
pname = "phonon-backend-gstreamer";
in
@ -11,18 +10,24 @@ stdenv.mkDerivation rec {
src = fetchurl {
url = "mirror://kde/stable/phonon/${pname}/${version}/src/${name}.tar.xz";
sha256 = "1cfjk450aajr8hfhnfq7zbmryprxiwr9ha5x585dsh7mja82mdw0";
sha256 = "1q1ix6zsfnh6gfnpmwp67s376m7g7ahpjl1qp2fqakzb5cgzgq10";
};
buildInputs = [ phonon qt4 gstreamer gst_plugins_base ];
buildInputs = with gst_all_1; [ phonon qt4 gstreamer gst-plugins-base ];
nativeBuildInputs = [ cmake automoc4 pkgconfig ];
NIX_CFLAGS_COMPILE = [
# This flag should be picked up through pkgconfig, but it isn't.
"-I${gst_all_1.gstreamer}/lib/gstreamer-1.0/include"
];
cmakeFlags = [ "-DCMAKE_INSTALL_LIBDIR=lib" ];
meta = {
homepage = http://phonon.kde.org/;
description = "GStreamer backend for Phonon";
platforms = stdenv.lib.platforms.linux;
};
maintainers = with stdenv.lib.maintainers; [ ttuegel ];
};
}

View file

@ -1,28 +0,0 @@
{ stdenv, fetchurl, cmake, automoc4, libpulseaudio, qt4 }:
with stdenv.lib;
let
v = "4.8.1";
in
stdenv.mkDerivation rec {
name = "phonon-${v}";
src = fetchurl {
url = "mirror://kde/stable/phonon/${v}/phonon-${v}.tar.xz";
sha256 = "1l97h1jj3gvl1chx1qbipizfvjgqc05wrhdcflc76c2krlk03jmn";
};
buildInputs = [ qt4 libpulseaudio ];
nativeBuildInputs = [ cmake automoc4 ];
meta = {
homepage = http://phonon.kde.org/;
description = "Multimedia API for Qt";
license = stdenv.lib.licenses.lgpl2;
platforms = stdenv.lib.platforms.linux;
maintainers = with stdenv.lib.maintainers; [ ttuegel ];
};
}

View file

@ -1,38 +0,0 @@
{ stdenv, fetchurl, cmake, mesa, pkgconfig, libpulseaudio
, qtbase, qtquick1, qttools
, debug ? false }:
with stdenv.lib;
let
v = "4.8.3";
in
stdenv.mkDerivation rec {
name = "phonon-${v}";
src = fetchurl {
url = "mirror://kde/stable/phonon/${v}/src/phonon-${v}.tar.xz";
sha256 = "05nshngk03ln90vsjz44dx8al576f4vd5fvhs1l0jmx13jb9q551";
};
buildInputs = [ mesa qtbase qtquick1 qttools libpulseaudio ];
nativeBuildInputs = [ cmake pkgconfig ];
NIX_CFLAGS_COMPILE = "-fPIC";
cmakeFlags = [
"-DCMAKE_BUILD_TYPE=${if debug then "Debug" else "Release"}"
"-DPHONON_BUILD_PHONON4QT5=ON"
"-DCMAKE_INSTALL_LIBDIR=lib"
];
meta = {
homepage = http://phonon.kde.org/;
description = "Multimedia API for Qt";
license = stdenv.lib.licenses.lgpl2;
platforms = stdenv.lib.platforms.linux;
maintainers = with stdenv.lib.maintainers; [ ttuegel ];
};
}

View file

@ -1,25 +0,0 @@
{ stdenv, fetchurl, cmake, pkgconfig, polkit, automoc4, glib
, qt4 ? null
, withQt5 ? false, qtbase ? null }:
with stdenv.lib;
assert (withQt5 -> qtbase != null); assert (!withQt5 -> qt4 != null);
stdenv.mkDerivation {
name = "polkit-qt-1-0.112.0";
src = fetchurl {
url = "mirror://kde/stable/apps/KDE4.x/admin/polkit-qt-1-0.112.0.tar.bz2";
sha256 = "1ip78x20hjqvm08kxhp6gb8hf6k5n6sxyx6kk2yvvq53djzh7yv7";
};
nativeBuildInputs = [ cmake pkgconfig ] ++ optional (!withQt5) automoc4;
propagatedBuildInputs = [ polkit glib ] ++ [(if withQt5 then qtbase else qt4)];
meta = {
description = "A Qt wrapper around PolKit";
maintainers = with stdenv.lib.maintainers; [ ttuegel ];
};
}

View file

@ -0,0 +1,21 @@
{ stdenv, fetchurl, cmake, pkgconfig, polkit, automoc4, glib, qt4 }:
with stdenv.lib;
stdenv.mkDerivation {
name = "polkit-qt-1-qt4-0.112.0";
src = fetchurl {
url = "mirror://kde/stable/apps/KDE4.x/admin/polkit-qt-1-0.112.0.tar.bz2";
sha256 = "1ip78x20hjqvm08kxhp6gb8hf6k5n6sxyx6kk2yvvq53djzh7yv7";
};
nativeBuildInputs = [ cmake pkgconfig automoc4 ];
propagatedBuildInputs = [ polkit glib qt4 ];
meta = {
description = "A Qt wrapper around PolKit";
maintainers = with stdenv.lib.maintainers; [ ttuegel ];
};
}

View file

@ -0,0 +1,29 @@
{ stdenv, fetchurl, cmake, pkgconfig, polkit, glib, qtbase }:
with stdenv.lib;
stdenv.mkDerivation {
name = "polkit-qt-1-qt5-0.112.0";
outputs = [ "dev" "out" ];
src = fetchurl {
url = "mirror://kde/stable/apps/KDE4.x/admin/polkit-qt-1-0.112.0.tar.bz2";
sha256 = "1ip78x20hjqvm08kxhp6gb8hf6k5n6sxyx6kk2yvvq53djzh7yv7";
};
nativeBuildInputs = [ cmake pkgconfig ];
propagatedBuildInputs = [ polkit glib qtbase ];
postFixup = ''
# Fix library location in CMake module
sed -i "$dev/lib/cmake/PolkitQt5-1/PolkitQt5-1Config.cmake" \
-e "s,\\(set_and_check.POLKITQT-1_LIB_DIR\\).*$,\\1 \"''${!outputLib}/lib\"),"
'';
meta = {
description = "A Qt wrapper around PolKit";
maintainers = with stdenv.lib.maintainers; [ ttuegel ];
};
}

View file

@ -24,11 +24,15 @@ makeQtWrapper() {
"$@"
}
# cannot use addToSearchPath because these directories may not exist yet
export QT_PLUGIN_PATH="$QT_PLUGIN_PATH${QT_PLUGIN_PATH:+:}${!outputLib}/lib/qt5/plugins"
export QML_IMPORT_PATH="$QML_IMPORT_PATH${QML_IMPORT_PATH:+:}${!outputLib}/lib/qt5/imports"
export QML2_IMPORT_PATH="$QML2_IMPORT_PATH${QML2_IMPORT_PATH:+:}${!outputLib}/lib/qt5/qml"
export XDG_CONFIG_DIRS="$XDG_CONFIG_DIRS${XDG_CONFIG_DIRS:+:}${!outputLib}/etc/xdg"
export XDG_DATA_DIRS="$XDG_DATA_DIRS${XDG_DATA_DIRS:+:}${!outputLib}/share"
export NIX_WRAP_XDG_CONFIG_DIRS="$NIX_WRAP_XDG_CONFIG_DIRS${NIX_WRAP_XDG_CONFIG_DIRS:+:}${!outputLib}/etc/xdg"
export NIX_WRAP_XDG_DATA_DIRS="$NIX_WRAP_XDG_DATA_DIRS${NIX_WRAP_XDG_DATA_DIRS:+:}${!outputLib}/share"
_makeQtWrapperSetup() {
# cannot use addToSearchPath because these directories may not exist yet
export QT_PLUGIN_PATH="$QT_PLUGIN_PATH${QT_PLUGIN_PATH:+:}${!outputLib}/lib/qt5/plugins"
export QML_IMPORT_PATH="$QML_IMPORT_PATH${QML_IMPORT_PATH:+:}${!outputLib}/lib/qt5/imports"
export QML2_IMPORT_PATH="$QML2_IMPORT_PATH${QML2_IMPORT_PATH:+:}${!outputLib}/lib/qt5/qml"
export XDG_CONFIG_DIRS="$XDG_CONFIG_DIRS${XDG_CONFIG_DIRS:+:}${!outputLib}/etc/xdg"
export XDG_DATA_DIRS="$XDG_DATA_DIRS${XDG_DATA_DIRS:+:}${!outputLib}/share"
export NIX_WRAP_XDG_CONFIG_DIRS="$NIX_WRAP_XDG_CONFIG_DIRS${NIX_WRAP_XDG_CONFIG_DIRS:+:}${!outputLib}/etc/xdg"
export NIX_WRAP_XDG_DATA_DIRS="$NIX_WRAP_XDG_DATA_DIRS${NIX_WRAP_XDG_DATA_DIRS:+:}${!outputLib}/share"
}
prePhases+=(_makeQtWrapperSetup)

View file

@ -121,11 +121,6 @@ stdenv.mkDerivation {
# The destination directory must exist or moveToOutput will do nothing
mkdir -p "$dev/share"
moveToOutput "share/doc" "$dev"
mkdir -p "$dev/lib"
lndir -silent "$out/lib" "$dev/lib"
if [[ -h "$dev/lib/cmake" ]]; then rm "$dev/lib/cmake"; fi
if [[ -h "$dev/lib/pkgconfig" ]]; then rm "$dev/lib/pkgconfig"; fi
}
preFixupHooks+=(_multioutQtDevs)

View file

@ -2,24 +2,18 @@ Index: qt-everywhere-opensource-src-5.5.1/qtbase/src/corelib/kernel/qcoreapplica
===================================================================
--- qt-everywhere-opensource-src-5.5.1.orig/qtbase/src/corelib/kernel/qcoreapplication.cpp
+++ qt-everywhere-opensource-src-5.5.1/qtbase/src/corelib/kernel/qcoreapplication.cpp
@@ -2498,6 +2498,22 @@ QStringList QCoreApplication::libraryPat
@@ -2498,6 +2498,16 @@ QStringList QCoreApplication::libraryPat
}
}
}
+ qunsetenv("QT_PLUGIN_PATH"); // do not propagate to child processes
+
+ // Add library paths derived from NIX_PROFILES.
+ const QByteArray nixProfilesEnv = qgetenv("NIX_PROFILES");
+ if (!nixProfilesEnv.isEmpty()) {
+ QLatin1Char pathSep(' ');
+ QStringList paths = QFile::decodeName(nixProfilesEnv).split(pathSep, QString::SkipEmptyParts);
+ for (QStringList::iterator it = paths.begin(); it != paths.end(); ++it) {
+ it->append("/lib/qt5/plugins");
+ QString canonicalPath = QDir(*it).canonicalPath();
+ if (!canonicalPath.isEmpty()
+ && !app_libpaths->contains(canonicalPath)) {
+ app_libpaths->append(canonicalPath);
+ }
+ const QByteArrayList profiles = qgetenv("NIX_PROFILES").split(' ');
+ const QString plugindir = QString::fromLatin1("/lib/qt5/plugins");
+ Q_FOREACH (const QByteArray &profile, profiles) {
+ if (!profile.isEmpty()) {
+ app_libpaths->append(QFile::decodeName(profile) + plugindir);
+ }
+ }
}

View file

@ -2,7 +2,7 @@ if [[ -z "$QMAKE" ]]; then
_qtLinkDependencyDir() {
@lndir@/bin/lndir -silent "$1/$2" "$qtOut/$2"
if [[ -n "$NIX_QT_SUBMODULE" ]]; then
if [ -n "$NIX_QT_SUBMODULE" ]; then
find "$1/$2" -printf "$2/%P\n" >> "$out/nix-support/qt-inputs"
fi
}
@ -22,13 +22,13 @@ _qtLinkModule() {
_qtRmModules() {
cat "$out/nix-support/qt-inputs" | while read file; do
if [[ -h "$out/$file" ]]; then
if [ -h "$out/$file" ]; then
rm "$out/$file"
fi
done
cat "$out/nix-support/qt-inputs" | while read file; do
if [[ -d "$out/$file" ]]; then
if [ -d "$out/$file" ]; then
rmdir --ignore-fail-on-non-empty -p "$out/$file"
fi
done
@ -43,11 +43,14 @@ addToSearchPathOnceWithCustomDelimiter() {
local dirs
local exported
IFS="$delim" read -a dirs <<< "${!search}"
for dir in ${dirs[@]}; do
if [ "z$dir" == "z$target" ]; then exported=1; fi
done
if [ -z $exported ]; then
eval "export ${search}=\"${!search}${!search:+$delim}$target\""
local canonical
if canonical=$(readlink -e "$target"); then
for dir in ${dirs[@]}; do
if [ "z$dir" == "z$canonical" ]; then exported=1; fi
done
if [ -z $exported ]; then
eval "export ${search}=\"${!search}${!search:+$delim}$canonical\""
fi
fi
}
@ -97,7 +100,7 @@ _qtMultioutDevs() {
}
qtOut=""
if [[ -z "$NIX_QT_SUBMODULE" ]]; then
if [ -z "$NIX_QT_SUBMODULE" ]; then
qtOut=`mktemp -d`
else
qtOut=$out

View file

@ -0,0 +1,20 @@
Index: qtdeclarative-opensource-src-5.5.1/src/qml/qml/qqmlimport.cpp
===================================================================
--- qtdeclarative-opensource-src-5.5.1.orig/src/qml/qml/qqmlimport.cpp
+++ qtdeclarative-opensource-src-5.5.1/src/qml/qml/qqmlimport.cpp
@@ -1549,6 +1549,15 @@ QQmlImportDatabase::QQmlImportDatabase(Q
QString installImportsPath = QLibraryInfo::location(QLibraryInfo::Qml2ImportsPath);
addImportPath(installImportsPath);
+ // Add library paths derived from NIX_PROFILES.
+ const QByteArrayList profiles = qgetenv("NIX_PROFILES").split(' ');
+ const QString qmldir = QString::fromLatin1("/lib/qt5/qml");
+ Q_FOREACH (const QByteArray &profile, profiles) {
+ if (!profile.isEmpty()) {
+ addImportPath(QFile::decodeName(profile) + qmldir);
+ }
+ }
+
// env import paths
QByteArray envImportPath = qgetenv("QML2_IMPORT_PATH");
if (!envImportPath.isEmpty()) {

View file

@ -0,0 +1,20 @@
Index: qtquick1-opensource-src-5.5.1/src/declarative/qml/qdeclarativeimport.cpp
===================================================================
--- qtquick1-opensource-src-5.5.1.orig/src/declarative/qml/qdeclarativeimport.cpp
+++ qtquick1-opensource-src-5.5.1/src/declarative/qml/qdeclarativeimport.cpp
@@ -725,6 +725,15 @@ QDeclarativeImportDatabase::QDeclarative
addImportPath(installImportsPath);
+ // Add library paths derived from NIX_PROFILES.
+ const QByteArrayList profiles = qgetenv("NIX_PROFILES").split(' ');
+ const QString importdir = QString::fromLatin1("/lib/qt5/imports");
+ Q_FOREACH (const QByteArray &profile, profiles) {
+ if (!profile.isEmpty()) {
+ addImportPath(QFile::decodeName(profile) + importdir);
+ }
+ }
+
// env import paths
QByteArray envImportPath = qgetenv("QML_IMPORT_PATH");
if (!envImportPath.isEmpty()) {

View file

@ -44,6 +44,8 @@ cmakeConfigurePhase() {
# executable. This flag makes the shared library accessible from its
# nix/store directory.
cmakeFlags="-DCMAKE_INSTALL_NAME_DIR=$prefix/lib $cmakeFlags"
cmakeFlags="-DCMAKE_INSTALL_LIBDIR=${!outputLib}/lib $cmakeFlags"
cmakeFlags="-DCMAKE_INSTALL_INCLUDEDIR=${!outputDev}/include $cmakeFlags"
# Avoid cmake resetting the rpath of binaries, on make install
# And build always Release, to ensure optimisation flags

View file

@ -8440,7 +8440,7 @@ in
pdf2xml = callPackage ../development/libraries/pdf2xml {} ;
phonon = callPackage ../development/libraries/phonon/qt4 {};
phonon = callPackage ../development/libraries/phonon {};
phonon_backend_gstreamer = callPackage ../development/libraries/phonon-backend-gstreamer/qt4 {};
@ -8469,7 +8469,7 @@ in
spidermonkey = spidermonkey_17;
};
polkit_qt4 = callPackage ../development/libraries/polkit-qt-1 { };
polkit_qt4 = callPackage ../development/libraries/polkit-qt-1/qt-4.nix { };
poppler = callPackage ../development/libraries/poppler { lcms = lcms2; };
@ -8575,15 +8575,13 @@ in
openbr = callPackage ../development/libraries/openbr { };
phonon = callPackage ../development/libraries/phonon/qt5 { };
phonon = callPackage ../development/libraries/phonon { };
phonon-backend-gstreamer = callPackage ../development/libraries/phonon-backend-gstreamer/qt5 { };
phonon-backend-vlc = callPackage ../development/libraries/phonon-backend-vlc/qt5 { };
polkit-qt = callPackage ../development/libraries/polkit-qt-1 {
withQt5 = true;
};
polkit-qt = callPackage ../development/libraries/polkit-qt-1/qt-5.nix { };
poppler = callPackage ../development/libraries/poppler {
lcms = lcms2;